i = 0; // used to index array of hits

graph_thickness = 3; // thickness of the graph's line
graph_bottom_offset = 4; // number of pixels from bottom of box to the graph's lowest point
graph_height = hits_mc._height; // height of graph container before line is drawn
graph_baseline_height = graph_height - graph_bottom_offset; // height graph area not including offset
graph_color = "0x" + _root.graph_color; // color of the graph line
graph_image = _root.graph_image; // image for display in middle of graph
update_interval = 1000 * _root.update_interval; // number of milliseconds between connections to script that processes log file


x_offset = 20; // determines how many pixels between graph points
x_next = x_offset; // used to keep track of the next x-coordinate


// create and position the graph
hits_mc.createEmptyMovieClip("graph_mc", 0);
hits_mc.graph_mc._x = hits_mc._width;
hits_mc.graph_mc._y = 0;

// load the background image
hits_mc.createEmptyMovieClip("logo_mc", 10);
hits_mc.logo_mc._alpha = 0;
hits_mc.logo_mc.loadMovie(unescape(graph_image));

// horizontal lines size and position
ten_mc._width = hits_mc._width;
ten_mc._x = hits_mc._x;
ten_mc._y = hits_mc._y + (graph_baseline_height * .5);

hundred_mc._width = hits_mc._width;
hundred_mc._x = hits_mc._x;
hundred_mc._y = hits_mc._y + (graph_baseline_height * .17);


// create text format and text fields for the graph lines' labels
graph_numbers_format = new textFormat();
graph_numbers_format.font = "arial";
graph_numbers_format.size = 10;
graph_numbers_format.color = 0x999999;

_root.createTextField("ten_txt",0,ten_mc._x,(ten_mc._y),300,100);
ten_txt.text = "10";
ten_txt.selectable = false;
ten_txt.setTextFormat(graph_numbers_format);

_root.createTextField("hundred_txt",2,hundred_mc._x,(hundred_mc._y),300,100);
hundred_txt.text = "100";
hundred_txt.selectable = false;
hundred_txt.setTextFormat(graph_numbers_format);

_root.createTextField("thousand_txt",3,hits_mc._x,(hits_mc._y),300,100);
thousand_txt.text = "1000";
thousand_txt.selectable = false;
thousand_txt.setTextFormat(graph_numbers_format);


// create an array for the buttons to simplify actions that affect all buttons
buttons_array = Array (

	show_ip_addresses_btn,
	show_hosts_btn,
	show_pages_btn,
	show_user_agents_btn,
	show_referrers_btn,
	show_countries_btn

);


for (button_index = 0; button_index < buttons_array.length; button_index++) {
	// apply the user-specified color to each button
	button_color = new Color(buttons_array[button_index]);
	button_color.setRGB(graph_color);
	
	// Use buttons on stage to toggle this value between true/false to add or remove a column from the tail display
	buttons_array[button_index].display = true;

}

// tracks whether the displays for last 10 hits and last hit should be updated
stop_tail_mc.update = true;
stop_last_hit_mc.update = true;


// create array to store hits
hits_mc.hits_all = new Array();




// functions


// connects to server-side script and loads resultant variables into hits_mc
function get_hits() {
	// reinitialize the countdown clock
	seconds_till_update = update_interval / 1000;
	
	// connect to script
	next_update_txt.text = "Contacting server...";
	hits_mc.loadVariables("reporter." + script_extension + "?realtime=1");
}

// countdown till next connection to script
function start_timer() {
	seconds_till_update--;
	next_update_txt.text = "Next update: " + seconds_till_update + " seconds";
	
	// call to function that connects to server
	if (seconds_till_update == 0) {
		get_hits();
	}
}

// calculates percentage of current hit delta compared to the range it belongs to
function get_percentage(hits_in, range_floor, range_ceiling) {
	return (hits_in - range_floor) / (range_ceiling - range_floor);
}

// calculates the y coordinate of the current graph point relative
function relative_height(percentage_range_in, percentage_graph_height) {
	return percentage_range_in * graph_baseline_height * percentage_graph_height;
}

// translates the relative y coordinate to the absolute coordinate within the graph's coordinate system
function absolute_height(range_offset, y_relative_in) {
	return graph_baseline_height - (graph_baseline_height * range_offset) - y_relative_in;
}

// parse the log files lines and display them in the text boxes on the stage
function update_log_display() {

		tail = _root.hits_mc.tail;
		
		tail_out = "";
		last_out = "";
		tail_lines = tail.split("\n");

		for(line=0; line < tail_lines.length; line++) {
		
			my_columns = new Array();
			
			tail_lines[line] = tail_lines[line].split("\t");
			
			if (tail_lines[line].length == 7) {
				
				the_date = tail_lines[line][0];
				ip_address = tail_lines[line][1];
				hostname = tail_lines[line][2];
				page = tail_lines[line][3];
				user_agent = tail_lines[line][4];
				referrer = tail_lines[line][5];
				country = tail_lines[line][6];
				
				if (hostname == ip_address) {
					hostname = "No host";
				}
				
				if (referrer == "") {
					referrer = "No referrer";
				}
				
				if (country == "--") {
					country = "No country";
				}
					
				if (show_ip_addresses_btn.display && ip_address != "") {
					my_columns.push(ip_address);
				}
				if (show_hosts_btn.display && hostname != "") {
					my_columns.push(hostname);
				}
				if (show_pages_btn.display && page != "") {
					my_columns.push(page);
				}
				if (show_user_agents_btn.display && user_agent != "") {
					my_columns.push(user_agent);
				}
				if (show_referrers_btn.display && referrer != "") {
					my_columns.push(referrer);
				}					
				if (show_countries_btn.display && country != "") {
					my_columns.push(country);
				}
				
				for(which_column = 0; which_column < my_columns.length; which_column++) {
					tail_out += my_columns[which_column];
					if (which_column != (my_columns.length - 1)) {
						tail_out += " ";
					}
				}
										
				if (line != (tail_lines.length - 1)) {
					tail_out += "\n";
				}
				
				if (line == (tail_lines.length - 1)) {
					last_out = the_date + " " + ip_address + " " + hostname + " " + page + " " + user_agent + " " + referrer + " " + country;
				}
			}
		}		
			
		if (_root.stop_tail_mc.update == true) {
			tail_txt.text = tail_out;
			tail_txt.scroll = tail_txt.maxscroll;
		}
			
		if (_root.stop_last_hit_mc.update == true) {
			last_hit_txt.text = last_out;
			last_hit_txt.scroll = last_hit_txt.maxscroll;
		}
}





// callback functions


// position the logo image after it loads
hits_mc.onEnterFrame = function() {

	if (this.logo_mc.getBytesLoaded() == this.logo_mc.getBytesTotal()) {
	
		logo_width = this.logo_mc._width;
		logo_height = this.logo_mc._width;
	
		if (logo_width > 0) {
			this.logo_mc._x = (this._width - logo_width) / 2;
			this.logo_mc._y = (this._height - logo_height) / 2;
			this.logo_mc._alpha = 20;	
			delete this.onEnterFrame;
		}
	}
}

// add or remove a column from the tail display, change color of the button
show_ip_addresses_btn.onRelease = show_hosts_btn.onRelease = show_pages_btn.onRelease = show_user_agents_btn.onRelease = show_referrers_btn.onRelease = show_countries_btn.onRelease = function() {

	this.display = this.display;
	
	if (this.display == true) {
		this.display = false;
		tint_color = new Color(this);
		tint_color.setRGB(0x999999);
	} else {
		this.display = true;
		tint_color = new Color(this);
		tint_color.setRGB(graph_color);
	}	
	
	update_log_display();
}

// toggle for displaying updated log file contents, changes color of button as well
stop_tail_mc.onRelease = stop_last_hit_mc.onRelease = function() {
	if (this.update == true) {
		this.gotoAndStop("red");
		this.update = false;
	} else {
		this.gotoAndStop("green");
		this.update = true;
		
		// update log display in case user has toggled columns on/off while updating was stopped
		_root.update_log_display();
	}
	
}

// when variables have loaded into movie
hits_mc.onData = function() {
		
	with (this) {
				
		// clear old timer, start the new timer
		clearInterval(my_timer);
		my_timer = setInterval(start_timer, 1000);
		
		// to do: this creates an array that never stops growing...this can be accomplished with a 2 element array
			if (i == 0) {
				hits_previous = hits;
				graph_mc.moveTo(x_next, graph_baseline_height);
			} else {
				hits_previous = hits_all[i - 1];
			}
			
			
			hits_all[i] = hits;
			hits_difference = hits_all[i] - hits_previous;
		
		// calculate the position of each hit		
		if (hits_difference > 0 && hits_difference <= 10) {
			percentage_of_range = get_percentage(hits_difference, 0, 10);
			y_relative = relative_height(percentage_of_range, .5)
			y_absolute = absolute_height(0, y_relative);
				
		} else if (hits_difference > 10 && hits_difference <= 100) {
			percentage_of_range = get_percentage(hits_difference, 10, 100);				
			y_relative = relative_height(percentage_of_range, .33)				
			y_absolute = absolute_height(.5, y_relative);		
				
		} else if (hits_difference > 100 && hits_difference <= 1000) {
			percentage_of_range = get_percentage(hits_difference, 100, 1000);				
			y_relative = relative_height(percentage_of_range, .17)
			y_absolute = absolute_height(.83, y_relative);			
				
		}
		
		// to do: need something for hits_difference greater than 1000
		else {
			y_absolute = graph_baseline_height - hits_difference;
		}
		
		// update the total hits and the name of the log file
		total_hits_txt.text = hits;
		data_file_txt.text = "Reading: " + data_file;
		
		// update the log display text fields		
		update_log_display();

		// draw the graph		
		graph_mc.lineStyle(graph_thickness, graph_color, 100);
		graph_mc.lineTo(x_next, y_absolute);
		
		// increment x and the hits count array index
		x_next = x_next + x_offset;
		i++;
		
		// move the graph
		graph_mc._x -= x_offset;
	}	
}


// start graphing manually the first time
get_hits();
